# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from mir_msgs/Event.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg

class Event(genpy.Message):
  _md5sum = "03782c584d14555433c75de52c9adea7"
  _type = "mir_msgs/Event"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """uint32 EV_SPEED=1
uint32 EV_BLINK=2
uint32 EV_SOUND=3
uint32 EV_DOOR=4
uint32 EV_AMCLOFF=5
uint32 EV_FWDDIST=6
uint32 EV_IO=7
uint32 EV_FLEETLCK=8	# Fleet
uint32 EV_EMERGENCY=9	# Fleet
uint32 eventType	# The area event type
string area_guid	# The area unique identifier
string area_name	# The name of the area
geometry_msgs/Point[] polygon # An array of corner points that define the edges of the area
================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z
"""
  # Pseudo-constants
  EV_SPEED = 1
  EV_BLINK = 2
  EV_SOUND = 3
  EV_DOOR = 4
  EV_AMCLOFF = 5
  EV_FWDDIST = 6
  EV_IO = 7
  EV_FLEETLCK = 8
  EV_EMERGENCY = 9

  __slots__ = ['eventType','area_guid','area_name','polygon']
  _slot_types = ['uint32','string','string','geometry_msgs/Point[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       eventType,area_guid,area_name,polygon

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Event, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.eventType is None:
        self.eventType = 0
      if self.area_guid is None:
        self.area_guid = ''
      if self.area_name is None:
        self.area_name = ''
      if self.polygon is None:
        self.polygon = []
    else:
      self.eventType = 0
      self.area_guid = ''
      self.area_name = ''
      self.polygon = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_get_struct_I().pack(self.eventType))
      _x = self.area_guid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.area_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.polygon)
      buff.write(_struct_I.pack(length))
      for val1 in self.polygon:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.polygon is None:
        self.polygon = None
      end = 0
      start = end
      end += 4
      (self.eventType,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.area_guid = str[start:end].decode('utf-8')
      else:
        self.area_guid = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.area_name = str[start:end].decode('utf-8')
      else:
        self.area_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.polygon = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        self.polygon.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_get_struct_I().pack(self.eventType))
      _x = self.area_guid
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.area_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.polygon)
      buff.write(_struct_I.pack(length))
      for val1 in self.polygon:
        _x = val1
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.polygon is None:
        self.polygon = None
      end = 0
      start = end
      end += 4
      (self.eventType,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.area_guid = str[start:end].decode('utf-8')
      else:
        self.area_guid = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.area_name = str[start:end].decode('utf-8')
      else:
        self.area_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.polygon = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        self.polygon.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
